<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: widget/Filedropper.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: widget/Filedropper.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * @license
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2014 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

define(['jquery', 'underscore', 'uweaver/lang', 'uweaver/widget/Widget' ,'uweaver/data/proxy/REST', 'uweaver/widget/Tooltips',
    'uweaver/exception/Violation', 'uweaver/string', 'uweaver/formatter'], function ($, _, lang, Widget, REST, Tooltips, Violation, string, formatter){
    var declare = lang.declare;
    var Base = Widget;
    var VALIDATIONERRORS = {
        'valueMissing': null,
        'typeMismatch': 'type',
        'patternMismatch': 'pattern',
        'tooLong': 'maxLength',
        'tooShort': 'minLength',
        'rangeUnderFlow': 'min',
        'rangeOverflow': 'max',
        'stepMismatch': 'step',
        'badInput': null};

    var ACCEPTITEMTYPES = {
        'image/*': /^image\//,
        'audio/*': /^audio\//,
        'video/*': /^video\//,
        '.txt': 'text/plain',
        '.csv': 'text/csv',
        '.pdf': 'application/pdf',
        '.xlsx': 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
        '.doc': 'application/msword',
        '.docx': 'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
        '.pptx': 'application/vnd.openxmlformats-officedocument.presentationml.presentation',
        '.zip': 'application/zip',
        '.json': 'application/json'
    };

    var FILEEXTICONS = {
        '.csv': 'file-text-o',
        '.txt': 'file-text-o',
        '.pdf': 'file-pdf-o',
        '.xlsx': 'file-excel-o',
        '.xls': 'file-excel-o',
        '.doc': 'file-word-o',
        '.docx': 'file-word-o',
        '.ppt': 'file-powerpoint-o',
        '.pptx': 'file-powerpoint-o'
    };

    var FILETYPEICONS = {};

    var EXTENTIONS = {
        'image/*': /[^\s]+(\.(jpg|png|gif|bmp))$/
    };

    /**
     * A Filebox is a widget for ....
     *
     * ##### JavaScript
     * ```javascript
     * var pictures = new Filedropper({
     *     el: $('[name=pictures]')
     * });
     * pictures.render();
     *
     * expect(pictures.value()).to.be.instanceof(Array);
     * ```
     * ##### HTML
     * + selector: div.
     *
     * ```html
     * &lt;form name="form" class="container form-horizontal">
     * ...
     *  &lt;div data-control="filedropper" name="pictures">
     * ...
     * &lt;/form>
     * ```
     *
     * ##### Events:
     * + 'change' - [value()]{@link Filedropper#value}, [add()]{@link Filedropper#add}, [remove()]{@link Filedropper#remove}
     *
     * @constructor Filedropper
     * @extends Widget
     * @author  Jason Lin
     * @since   1.0
     * @param {Object} [config] - A map of configuration to pass to the constructor.
     * @param {String} config.name - A text string to specify the name. Required.
     * @param {String} [config.value] - Specifies the value(files) of the filedropper.
     * @param {Boolean} [config.multiple=false] - specifies that the user is allowed to enter more than one file in the filedropper.
     * @param {String} [config.accept] - the accepted content type.
     * @param {Boolean} [config.readonly=false] - Specifies that the filedropper is read-only.
     * @param {Boolean} [config.required=false] - Specifies that the filedropper must have at least one file.
     * @param {Boolean} [config.disabled=false] - Specifies that the filedropper should be disabled.
     * @param {Integer} [config.maxLength] - Specifies the maximum number of files allowed in the filedropper.
     * @param {Integer} [config.minLength] - Specifies the minimum number of files allowed in the filedropper.
     * @param {Function} [config.dropHandler] - Specifies the handler to invoke when file(s) dropped.
     * @param {Function} [config.deleteHandler] - Specifies the handler to invoke before the user deletes the file.
     */
    function initialize(config) {
        Base.prototype.initialize.apply(this, arguments);

        var defaults = {};
        var cfg = this.cfg();
        
        _.defaults(cfg, defaults);

        cfg.dropHandler &amp;&amp; (this._dropHandler = cfg.dropHandler);
        cfg.deleteHandler &amp;&amp; (this._deleteHandler = cfg.deleteHandler);

        this._items = [];
        this._index = 0;

        this.$el.css({
            'position': 'relative',
            'overflow': 'hidden'
        });

        this._$image = $('&lt;img>');
        this._$image.css({
            position: 'relative',
            display: 'block',
            'margin-left': 'auto',
            'margin-right': 'auto'
        });
        this.$el.append(this._$image);
        this._$image.hide();
        this._$image.on('load', _.bind(onImageLoad, this));
        this._$image.on('error', _.bind(onImageError, this));

        this._$text = $('&lt;div>&lt;/div>');
        this._$text.css({
            position: 'relative',
            display: 'block',
            'margin-left': 'auto',
            'margin-right': 'auto'
        });
        this.$el.append(this._$text);
        this._$text.hide();

        this._$info = $('&lt;div>&lt;/div>');
        this._$info.css({
            position: 'relative',
            display: 'block',
            'margin-left': 'auto',
            'margin-right': 'auto'
        });
        this.$el.append(this._$info);
        this._$info.hide();

        this._$remove = $('&lt;i>');
        this._$remove.addClass('fa fa-remove');
        this._$remove.css({
            position: 'absolute',
            cursor: 'pointer',
            display: 'none',
            'font-size': 'larger'
        });
        this.$el.append(this._$remove);

        this._$readonlyCover = $("&lt;div class='uw-background-gray' style='position:absolute;opacity:0.2'>&lt;/div>");
        this._$readonlyCover.css({left:0, top:0});
        this.$el.append(this._$readonlyCover);

        this._$previous = $('&lt;i>');
        this._$previous.addClass('fa fa-chevron-left');
        this._$previous.css({
            position: 'absolute',
            cursor: 'pointer',
            display: 'none',
            'font-size': 'larger'
        });
        this.$el.append(this._$previous);

        this._$next = $('&lt;i>');
        this._$next.addClass('fa fa-chevron-right');
        this._$next.css({
            position: 'absolute',
            cursor: 'pointer',
            display: 'none',
            'font-size': 'larger'
        });
        this.$el.append(this._$next);

        this.$el.on("dragover", _.bind(onDragOver, this));
        this.$el.on("drop", _.bind(onDrop, this));
        // this.$el.on("dragleave", _.bind(onDragLeave, this));

        this._$previous.on('click', _.bind(onPrevious, this));
        this._$next.on('click', _.bind(onNext, this));
        this._$remove.on('click', _.bind(onRemove, this));

        this._$disabledCover = $("&lt;div class='uw-background-gray' style='position:absolute;opacity:0.6'>&lt;/div>");
        this._$disabledCover.css({left:0, top:0});
        this.$el.append(this._$disabledCover);


        $(window).on('resize', _.bind(render, this));

        this._rest = new REST();

        var tooltips = new Tooltips({
            target: this
        }).render();

        this._tooltips = tooltips;

        (cfg.multiple!==undefined) &amp;&amp; this.multiple(cfg.multiple);
        (cfg.accept!==undefined) &amp;&amp; this.accept(cfg.accept);
        (cfg.required!==undefined) &amp;&amp; this.required(cfg.required);
        (cfg.maxLength!==undefined) &amp;&amp; this.maxLength(cfg.maxLength);
        (cfg.minLength!==undefined) &amp;&amp; this.minLength(cfg.minLength);
        (cfg.readonly!==undefined) &amp;&amp; this.readonly(cfg.readonly);
        (cfg.disabled!==undefined) &amp;&amp; this.disabled(cfg.disabled);

        this.disabled(this.disabled());
        this.readonly(this.readonly());
        this.accept(this.accept());

        this.clearValidation();

    }

    function render(options) {
        if(this.$el.width()&lt;=0) {
            _.delay(_.bind(render, this), 1000, options);
            return this;
        }

        options || (options = {});

        var item = this.get();

        renderItem.call(this, item);

        renderControls.call(this);

        this._$disabledCover.outerWidth(this.$el.outerWidth()); this._$disabledCover.outerHeight(this.$el.outerHeight());
        this._$readonlyCover.outerWidth(this.$el.outerWidth()); this._$readonlyCover.outerHeight(this.$el.outerHeight());

        return this;
    }

    function renderControls() {

        var item = this.get();

        if(this.size()>1) {
            this._$previous.css({
                top: this.$el.outerHeight() - 30,
                left: 10
            });
            this._$next.css({
                top: this.$el.outerHeight() - 30,
                left: this.$el.outerWidth() - 30
            });
            this._$previous.show();
            this._$next.show();
        } else {
            this._$previous.hide();
            this._$next.hide();
        }

        if(this.size()>0 &amp;&amp; (!this.deleteHandler() || this.deleteHandler()(item))) {
            this._$remove.css({
                top: 10,
                left: this.$el.outerWidth() - 30
            });
            this._$remove.show();
        } else {
            this._$remove.hide();
        }
    }

    function renderItem(item) {
        this._$image.hide();
        this._$text.hide();
        this._$info.hide();

        if(!item) return;


        renderInfo.call(this, item);

        if(/^image\/.*$/.test(item.type)) {
            renderImageItem.call(this, item);
        }
        
    }
    
    function renderImageItem(item) {
        this._$image.css({
            height: 'auto',
            width: 'auto'
        });
        
        if(item instanceof File) {
            var reader = new FileReader();
            reader.onload = _.bind(function(event) {
                this._$image.prop('src', event.target.result);

            }, this);

            reader.readAsDataURL(item);
        } else {

            var url = _.isFunction(item.url) ? item.url() : item.url;

            this._$image.prop('src', this._rest.dataUrl(url));
        }

        this._$image.data('item', item);
    }
    
    function renderTextItem(item) {
        
    }
    
    function renderInfo(item) {
        var ext = /\.[0-9a-z]+$/i.exec(item.name);
        var template = "&lt;table>&lt;tr>&lt;td>&lt;i class='fa fa-${icon}'>&lt;/i>&lt;/td>&lt;td>${name}&lt;br>${size} bytes&lt;/td>&lt;/tr>&lt;/table>";
        var icon = _.has(FILEEXTICONS, ext) ? FILEEXTICONS[ext] : 'file';
        var size = (item.size || item.size===0) ? formatter.format(item.size) : '?';

        var html = string.substitute(template, {
            icon: icon,
            name: item.name,
            size: size
        });

        this._$info.html(html);

        this._$info.find('table').css({
            'margin-left': 'auto',
            'margin-right' : 'auto',
            height: '100%'
        });
        this._$info.find('i').css({
            'font-size': '60px',
            'margin-right': '12px'
        });

        this._$info.height(this.$el.height());
        this._$info.data('item', item);
        this._$info.show();
    }

    function onImageLoad() {
        var item = this._$image.data('item');
        if(this._$info.data('item')!==item) return;

        this._$info.hide();
        var wRatio = this._$image.width() / this.$el.width();
        var hRatio = this._$image.height() / this.$el.height();
        if(wRatio > hRatio) {
            this._$image.width(this.$el.width());
        } else {
            this._$image.height(this.$el.height());
        }

        var top = (this.$el.height() - this._$image.height()) / 2;
        this._$image.css('top', top);

        this._$image.show();
    }

    function onImageError() {
        var item = this._$image.data('item');
        if(this._$info.data('item')!==item) return;

        this._$info.hide();
        var template = "&lt;table>&lt;tr>&lt;td>&lt;i class='fa fa-${icon}'>&lt;/i>&lt;/td>&lt;td>${name}&lt;br>${size} bytes&lt;/td>&lt;/tr>&lt;/table>";
        var icon = 'chain-broken';
        var size = (item.size || item.size===0) ? formatter.format(item.size) : '?';

        var html = string.substitute(template, {
            icon: icon,
            name: item.name,
            size: size
        });

        this._$info.html(html);

        this._$info.find('table').css({
            'margin-left': 'auto',
            'margin-right' : 'auto',
            height: '100%'
        });
        this._$info.find('i').css({
            'font-size': '60px',
            'margin-right': '12px'
        });

        this._$info.height(this.$el.height());
        this._$info.show();
    }

    
    function onDrop(event) {
        event.stopPropagation();
        event.preventDefault();

        if(this.readonly()||this.disabled()) return;

        this.drop(event.dataTransfer.files);
    }

    /**
     * Get or set the handler to invoke when the files dropped.
     *
     * The files dropped are passed as the parameter and the handler should return the files to be stored.
     *
     * ##### JavaScript
     * ```javascript
     * var pictures = new Filedropper({
     *     el: $('[name=pictures]')
     * });
     *
     * function handler(files) {
     *      Date now = new Date();
     *
     *      _.each(files, function(file){
     *          file.dateAdded = now;
     *      });
     *
     *      return files;
     * }
     *
     * pictures.dropHandler(handler);
     * ```
     *
     * @memberof Filedropper#
     * @param {Function} fn - The handler.
     * @returns {Function|void}
     */
    function dropHandler(fn) {
        if(arguments.length===0) return this._dropHandler;

        this._dropHandler = fn;
    }

    /**
     * Get or set the handler to invoke before the user deletes the file.
     *
     * The file is passed as the parameter to the handler. The handler return true to allow the file to be deleted.
     *
     * ##### JavaScript
     * ```javascript
     * var pictures = new Filedropper({
     *     el: $('[name=pictures]')
     * });
     *
     * function handler(file) {
     *      return file.readonly;
     * }
     *
     * pictures.deleteHandler(handler);
     * ```
     *
     * @memberof Filedropper#
     * @param {Function} fn - The handler.
     * @returns {Function|void}
     */
    function deleteHandler(fn) {
        if(arguments.length===0) return this._deleteHandler;

        this._deleteHandler = fn;
    }

    function onDragOver(event) {
        event.stopPropagation();
        event.preventDefault();
        
        var items = event.dataTransfer.items;

        if(this.readonly()||this.disabled()|| !validateTransferItems.call(this, items)
            ||(this.size() + items.length> this.maxLength())) {
            event.dataTransfer.dropEffect = 'none';
        } else {
            event.dataTransfer.dropEffect = 'copy';
        }
    }

    function validateTransferItems(items) {
        var valid = true;

        _.each(items, function(item) {
            item.kind==='file' || (valid = false);
        });

        if(!valid) return false;

        var acceptItemTypes = this._acceptItemTypes;

        if(!acceptItemTypes) return true;

        _.each(items, function(item) {
            if(!valid) return;

            var type = _.find(acceptItemTypes, function(type) {
                if(type instanceof RegExp) {
                    return type.test(item.type);
                } else {
                    return (item.type===type);
                }
            });

            valid = (type) ? true : false;
        });

        return valid;
    }

    function validateFiles(files) {
        var valid = true;
        var regExp;
        if(!regExp) {
            var pattern = accept.replace(',', '|').replace('\.', '');
            regExp = new RegExp("[^\\s]+(\\.(" + pattern + "))$");
        }
        _.each(items, function(item) {
            if(!reg.test(item.type)) {
                valid = false;
            }
        });
        return valid;

    }

    // function onDragLeave(event) {
    //     if(event.target!==this._$image.get(0)) return;
    //
    //     event.stopPropagation();
    //     event.preventDefault();
    //
    //     var item = $(event.target).data('item');
    //
    //     if(item!==this.get()) return;
    //
    //     this.remove(item);
    // }

    function onRemove() {
        this.remove();
    }


    function onPrevious() {
        this.previous();
    }

    function onNext() {
        this.next();
    }

    /**
     * Add a file to the filedropper.
     *
     * ##### Events:
     * + 'change' - triggered after added. event.data => the files.
     *
     * @memberof Filedropper#
     * @param {File|Object} file - The file to add.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.selected=true] - A false value to prevent the new file from being selected.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @returns {Filedropper} this
     */
    function add(item, options) {
        if(item===undefined) return this;

        var defaults = {
            index: this.size()
        };

        options || (options = {});

        _.defaults(options, defaults);

        item instanceof File &amp;&amp; (item.toJSON = fileToJSON);

        this._items.splice(options.index, 0, item);


        if(options.silent) return this;

        this.goto(options.index);

        this.validate() &amp;&amp; this.change();

        return this;
    }

    /**
     * Remove a file to the filedropper.
     *
     * ##### Events:
     * + 'change' - triggered after added. event.data => the files.
     *
     * @memberof Filedropper#
     * @param {File|Object|Integer} file - The file(or index of file) to remove.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @returns {Filedropper} this
     */
    function remove(item, options) {
        if(item===undefined) item = this._index;

        options || (options = {});

        var index = _.isNumber(item) ? item : _.findIndex(this.value(), function(n) {
            return n === item;
        });

        if(!index &amp;&amp; index!==0) return;

        this._items.splice(index, 1);

        if(options.silent) return this;

        this.goto(index-1);

        this.validate() &amp;&amp; this.change();

        return this;
    }

    /**
     * Get the file.
     *
     * @memberof Filedropper#
     * @param {Integer} index - The index of file. zero-based.
     * @returns {File}
     */
    function get(index) {
        if(arguments.length===0) index = this._index;

        if(!index &amp;&amp; index!==0) return;

        if(index>this.size() || index&lt;0) return null;
        
        return this._items[index];
    }

    function size() {
        return this._items.length;
    }

    function previous() {
        return this.goto(this._index-1);
    }

    function next() {
        return this.goto(this._index+1);
    }
    
    function first() {
        return this.goto(0);
    }
    
    function last() {
        return this.goto(this.size()-1);
    }

    function goto(which) {
        if(which===undefined) return this;

        if(this.current()===which) return this;

        var index = _.isNumber(which) ? which : _.findIndex(this._items, function(n) {
            return n === which;
        });

        this._index = Math.max(Math.min(index, this.size()-1), 0);

        this.render();

        this.trigger('select', {
            data: which,
            context: this,
            source: this
        });

        return this;
    }
    
    function value(items, options) {
        options || (options = {});
        
        if(arguments.length===0) {
            if(this.multiple()) {
                return (this.size()===0) ? null : this._items;
            } else {
                return (this.size()===0) ? null : _.first(this._items);
            }
        }

        items || (items = []);

        _.isArray(items) || (items = [items]);

        if(equals.call(this, items)) return;

        _.each(items, function(item) {
            item instanceof File &amp;&amp; (item.toJSON = fileToJSON);
        });

        this._items = items;
        this._index = 0;

        this.goto(0);

        this.validate() &amp;&amp; (options.silent || this.change());
    }

    function index() {
        return this._index;
    }

    function current() {
        return this.get();
    }
    
    function clear() {
        this._items = [];
        this._index = 0;

        this.render();
        this.clearValidation();
    }

    function equals(items) {
        return JSON.stringify(items) === JSON.stringify(this._items);
    }

    function fileToJSON() {
        var json = {};

        _.each(this, function(value, key) {
            json[key] = value;
        });

        json.name = this.name;
        json.type = this.type;
        json.size = this.size;

        return json;
    }
    
    function change() {
        this.trigger('change', {
            data: this.value(),
            context: this,
            source: this
        });
    }

    function drop(files) {
        this.dropHandler() &amp;&amp; (files = this.dropHandler()(files));

        if(!files||files.length===0) return;

        if(this.size() + files.length > this.maxLength()) {
            return;
        }
        _.each(files, function(file) {
            this.add(file, {silent: true});
        }, this);

        this.last();

        this.trigger('drop', {
            data: files,
            context: this,
            source: this
        });

        this.render();

        this.validate() &amp;&amp; this.change();
    }

    function name(name) {

        if(!name) return this.$el.attr('name');

        this.$el.attr('name', name);
    }

    function type() {
        var $component = this.$el;

        return $component.attr('type');
    }

    function clearValidation() {
        this._violations = [];
        this._tooltips.content("");
        this.removeClass('uw-border-warn');
    }

    function readonly(value) {
        if(arguments.length===0) return this.el.hasAttribute('readonly');

        if(value) {
            this.el.setAttribute('readonly', null);
            this._$readonlyCover.show();
        } else {
            this.el.removeAttribute('readonly');
            this._$readonlyCover.hide();
        }
    }

    function required(value) {
        if(arguments.length===0) return this.el.hasAttribute('required');

        value ? this.el.setAttribute('required', null) : this.el.removeAttribute('required');
    }

    function disabled(value) {
        if(arguments.length===0) return this.el.hasAttribute('disabled');

        if(value) {
            this.el.setAttribute('disabled', null);
            this._$disabledCover.show();
        } else {
            this.el.removeAttribute('disabled');
            this._$disabledCover.hide();
        }
    }

    function maxLength(value) {
        var $component = this.$el;

        if(arguments.length===0) {
            if(!this.el.hasAttribute('multiple')) return 1;

            var value = Number($component.attr('maxLength'));

            return value;
        }

        $component.attr('maxLength', value);
    }

    function minLength(value) {
        var $component = this.$el;
        if(arguments.length===0) return Number($component.attr('minLength'));
        $component.attr('minLength', value);
    }

    function multiple(value) {
        if(arguments.length===0) return this.el.hasAttribute('multiple');

        value ? this.el.setAttribute('multiple', null) : this.el.removeAttribute('multiple');
    }
    
    function accept(value) {
        var $component = this.$el;
        if(arguments.length===0) return $component.attr('accept');
        $component.attr('accept', value);


        if(value &amp;&amp; value.length>0) {
            var accepts = this.accept().split(',');

            var itemTypes = [];

            _.each(accepts, function(accept) {

                if(_.has(ACCEPTITEMTYPES, accept)) {
                    itemTypes.push(ACCEPTITEMTYPES[accept]);
                } else if(accept.indexOf('/')!==-1) {
                    itemTypes.push(accept);
                } else {
                    itemTypes.push(/^(.)+\/(.)+/);
                    itemTypes.push('');

                }
            });
            this._acceptItemTypes = itemTypes;
        } else {
            this._acceptItemTypes = undefined;
        }

    }

    /**
     * Validate the value of the inputbox.
     */
    function validate() {
        var $control = this.$el;
        var validity = $control.prop('validity');
        var valid = true;

        this.clearValidation();

        (valid &amp;&amp; _.isObject(validity)) &amp;&amp; (valid = this.checkValidity());

        (valid &amp;&amp; this.useCustomType()) &amp;&amp; (valid = this.customValidate());

        return valid;
    }

    function checkValidity() {
        var $input = this.$el;
        var validity = $input.prop('validity');

        if(!validity.valid) {
            _.each(VALIDATIONERRORS, function(prop, error) {
                if(validity[error]) {
                    var parameters = [];
                    if(prop) {
                        parameters.push($input.prop(prop)||$input.attr(prop));
                    }
                    this.violate(new Violation({
                        properties: [this.name()],
                        error: error.toUpperCase(),
                        parameters: parameters
                    }));
                }
            }, this);

            var validationMessage = "";
            _.each(this._violations, function(violation) {
                validationMessage = validationMessage + '\n' + violation.toString();
            });
            $input.get(0).setCustomValidity(validationMessage);
        }


        return validity.valid;
    }

    function useCustomType() {
        return true;
    }

    function customValidate() {
        var valid = true;

        this.validateRequired() || (valid = false);
        this.validateMaxLength() || (valid = false);
        this.validateMinLength() || (valid = false);

        return valid;
    }

    function validateRequired() {
        if(!this.required()) return true;

        if(this.size()===0) {
            this.violate(new Violation({
                properties: [this.name()],
                error: Violation.Error.VALUEMISSING
            }));
            return false;
        }

        return true;
    }

    function validateMaxLength() {
        if(!this.maxLength()) return true;

        if(this.size()>this.maxLength()) {
            this.violate(new Violation({
                properties: [this.name()],
                error: Violation.Error.TOOLONG,
                parameters: [this.maxLength()]
            }));
            return false;
        }

        return true;
    }

    function validateMinLength() {
        if(!this.minLength()) return true;

        if(this.size()&lt;this.minLength()) {
            this.violate(new Violation({
                properties: [this.name()],
                error: Violation.Error.TOOSHORT,
                parameters: [this.minLength()]
            }));
            return false;
        }

        return true;
    }

    function violate(violation) {
        if(!violation) return;

        this._violations.push(violation);

        this.hasClass('uw-border-warn') || this.addClass('uw-border-warn');

        this._tooltips.append(violation.toString() + "&lt;br>");

        return violation;
    }


    function violations() {
        return this._violations;
    }

    function state(value) {
        if(arguments.length===0) return this._state;

        this._state = value.toUpperCase();

        this.readonlyState() &amp;&amp; this.readonly(_.contains(this.readonlyState().toUpperCase().split(","), this._state));
        this.disabledState() &amp;&amp; this.disabled(_.contains(this.disabledState().toUpperCase().split(","), this._state));
        this.hiddenState() &amp;&amp; _.contains(this.hiddenState().toUpperCase().split(","), this._state) ? this.hide() : this.show();
    }

    function readonlyState(value) {
        var $input = this.$el;
        if(arguments.length===0) return $input.attr('data-readonly-state');
        $input.attr('data-readonly-state', value);
    }

    function disabledState(value) {
        var $input = this.$el;
        if(arguments.length===0) return $input.attr('data-disabled-state');
        $input.attr('data-disabled-state', value);
    }

    function hiddenState(value) {
        var $input = this.$el;
        if(arguments.length===0) return $input.attr('data-hidden-state');
        $input.attr('data-hidden-state', value);
    }

    /**
     * @todo
     * @param hint
     * @returns {*}
     */
    function placeholder(hint) {
    }

    var props = {
        _items: undefined,
        _index: undefined,
        _$image: undefined,
        _$text: undefined,
        _$info: undefined,
        _$previous: undefined,
        _$next: undefined,
        _$remove: undefined,
        _dropHandler: undefined,
        _deleteHandler: undefined,
        _rest: undefined,
        _state: undefined,
        _acceptItemTypes: undefined
    };

    var Filedropper = declare(Base, {
        initialize: initialize,
        render: render,
        value: value,
        index: index,
        current: current,
        clear: clear,
        previous: previous,
        first: first,
        last: last,
        next: next,
        goto: goto,
        get: get,
        size: size,
        add: add,
        remove: remove,
        drop: drop,
        name: name,
        type: type,
        placeholder: placeholder,
        validate: validate,
        violate: violate,
        violations: violations,
        checkValidity: checkValidity,
        useCustomType: useCustomType,
        customValidate: customValidate,
        clearValidation: clearValidation,
        validateRequired: validateRequired,
        validateMaxLength: validateMaxLength,
        validateMinLength: validateMinLength,
        multiple: multiple,
        readonly: readonly,
        required: required,
        disabled: disabled,
        maxLength: maxLength,
        minLength: minLength,
        accept: accept,
        state: state,
        readonlyState: readonlyState,
        disabledState: disabledState,
        hiddenState: hiddenState,
        change: change,
        dropHandler: dropHandler,
        deleteHandler: deleteHandler
    }, props);

    return Filedropper;
});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
